using System;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.WebEdition;

namespace CSSamples.Samples
{
    public partial class DisplayASimpleMap : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Map1.MapBackground.BackgroundBrush = new GeoSolidBrush(GeoColor.FromHtml("#E5E3DF"));
                Map1.CurrentExtent = new RectangleShape(-125, 72, 50, -46);
                Map1.MapUnit = GeographyUnit.DecimalDegree;

                //WorldMapKitWmsWebOverlay worldMapKitOverlay = new WorldMapKitWmsWebOverlay();
                //Map1.CustomOverlays.Add(worldMapKitOverlay);

                InMemoryFeatureLayer markerLabelsOverlay = new InMemoryFeatureLayer();
                markerLabelsOverlay.Open();
                markerLabelsOverlay.Columns.Add(new FeatureSourceColumn("Name"));
                markerLabelsOverlay.Close();
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = PointStyles.City1;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle = TextStyles.CreateSimpleTextStyle("Name", "Verdana", 10, DrawingFontStyles.Bold, GeoColor.StandardColors.Black, -58, 15);
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.OverlappingRule = LabelOverlappingRule.NoOverlapping;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.FittingLineInScreen = true;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.FittingPolygon = true;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.SplineType = SplineType.StandardSplining;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.SuppressPartialLabels = true;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.GridSize = 10;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.BestPlacement = true;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.DrawingLevel = DrawingLevel.LevelOne;
                markerLabelsOverlay.ZoomLevelSet.ZoomLevel01.DefaultTextStyle.RequiredColumnNames.Add("Name");

                Random r = new Random(DateTime.Now.Millisecond);
                for (int i = 0; i < 10; i++)
                {
                    Feature feature = new Feature(-94.558 + i * 0.001, 39.078 + i * 0.001);
                    feature.ColumnValues["Name"] = Guid.NewGuid().ToString();
                    markerLabelsOverlay.InternalFeatures.Add(feature);

                    Feature feature1 = new Feature(-94.558 - i * 0.001, 39.078);
                    feature1.ColumnValues["Name"] = Guid.NewGuid().ToString();
                    markerLabelsOverlay.InternalFeatures.Add(feature1);

                    Feature feature2 = new Feature(-94.558 + i * r.NextDouble(), 39.078);
                    feature2.ColumnValues["Name"] = Guid.NewGuid().ToString();
                    markerLabelsOverlay.InternalFeatures.Add(feature2);
                }
                Map1.DynamicOverlay.Layers.Add("Vehicle Marker Labels", markerLabelsOverlay);

                //LayerOverlay overlay = new LayerOverlay();
                //overlay.Layers.Add(markerLabelsOverlay);
                Map1.StaticOverlay.Layers.Add(markerLabelsOverlay);

                Map1.CurrentExtent = new RectangleShape(-95.658, 40.078, -95.558, 40.028);
            }
        }
    }
}
